


		*****************************************
		***PANEL tous salariés + EDP 1976-2018***
		*****************************************


**********************
***Merge Panel 2018***
**********************

{

clear all
set more off

append using "$sources${sep}panel_ts_edp_76_93"
append using "$sources${sep}panel_ts_edp_94_01"
append using "$sources${sep}panel_ts_edp_02_07"
append using "$sources${sep}panel_ts_edp_08_12"
append using "$sources${sep}panel_ts_edp_13_18"

compress

erase "$sources${sep}panel_ts_edp_76_93.dta"
erase "$sources${sep}panel_ts_edp_94_01.dta"
erase "$sources${sep}panel_ts_edp_02_07.dta"
erase "$sources${sep}panel_ts_edp_08_12.dta"
erase "$sources${sep}panel_ts_edp_13_18.dta"

save "$sources${sep}panel_edp_2018", replace

}
*

**********
***Data***
**********

{

clear all
set more off
use "$sources${sep}panel_edp_2018.dta"


	**************
	***Cleaning***
	**************

	
***Missing identifiers
drop if nninouv=="" | nninouv=="." //workers' identifier

***Rename variables 
rename nninouv idnr
rename annai b_year
rename an year

***Education

drop if dip_tot==""

gen educ = 1 if (dip_tot=="1" | dip_tot=="2" | dip_tot=="3" | dip_tot=="4") //less than high-school (no diploma + less than junior HS + junior HS + vocational less than bac)
replace educ = 2 if (dip_tot=="5") // High-school (Baccalauréat)
replace educ = 3 if (dip_tot=="6") // College 2yr
replace educ = 4 if (dip_tot=="7") // College more than 2yr


	******************
	***Save dataset***
	******************

keep idnr year educ

*One observation per individual
sort idnr year educ
bys idnr: gen id = _n if educ !=.

keep if id==1

drop id year

compress

save "$processing${sep}panel_ts_edp_2018_clean.dta", replace
}
*


