

	**********************
	****Additional Data***
	**********************

************************************************
***Master sample + additional characteristics***
************************************************

***Add variables to main sample (e.g. hours, place of residence, jobs characteristics)

{

forvalue yr = 1991/2016 {
clear all
set more off

if `yr'<1993 use labor`yr' logearn`yr' researn`yr' researn1F`yr' researn5F`yr' yob male personid using "$maindir${sep}dta${sep}master_sample.dta" 
if `yr'>=1993 & `yr'< 2012 use labor`yr' logearn`yr' researn`yr' researn1F`yr' researn5F`yr' permearn`yr' permearnalt`yr' yob male personid using "$maindir${sep}dta${sep}master_sample.dta" 
if `yr'> 2011 & `yr'<2016 use labor`yr' logearn`yr' researn`yr' researn1F`yr' permearn`yr' permearnalt`yr' yob male personid using "$maindir${sep}dta${sep}master_sample.dta" 
if `yr'== 2016 use labor`yr' logearn`yr' researn`yr' permearn`yr' permearnalt`yr' yob male personid using "$maindir${sep}dta${sep}master_sample.dta"  

keep if labor`yr' != .
rename labor`yr' labor
rename logearn`yr' logearn
rename researn`yr' researn
if `yr'>=1993 {
	rename permearn`yr' permearn
	rename permearnalt`yr' permearnalt
}
if `yr'>=1993 & `yr'< 2012 rename researn5F`yr' researn5F
if `yr'>=1993 & `yr'<2016 rename researn1F`yr' researn1F


gen year = `yr'

save "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_`yr'.dta", replace
}
*

clear
forvalue yr = 1991/2016 {
append using "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_`yr'.dta"
}

drop if year<1991

merge 1:1 personid year using "$maindir_replication${sep}Part_B${sep}dta${sep}additional_var.dta"
drop if _merge==2 
drop _merge

*

save "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_long.dta", replace

forvalue yr = 1991/2016 {
erase "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_`yr'.dta"
}
*
}
*

***************************************************
***Hours & Hourly wage by percentile of earnings***
***************************************************

{

clear all
set more off
use "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_long"

keep if logearn!=.

gen obs = 1
gen ihours = 1

**Small bins around percentile

gen percentile = 0
gen percentile_m = 0
gen percentile_f = 0

*Whole Population

forvalue yr=1993/2016 {

	qui _pctile logearn if year==`yr', p(4.8, 5.2)	
	qui replace percentile = 1 if logearn>=r(r1) & logearn<=r(r2) & year==`yr'  //P5

	*

	qui _pctile logearn if year==`yr', p(9.8, 10.2)	
	qui replace percentile = 2 if logearn>=r(r1) & logearn<=r(r2) & year==`yr'  //P10

	*

	qui _pctile logearn if year==`yr', p(24.8, 25.2)	
	qui replace percentile = 3 if logearn>=r(r1) & logearn<=r(r2) & year==`yr'  //P25

	*

	qui _pctile logearn if year==`yr', p(49.8, 50.2)	
	qui replace percentile = 4 if logearn>=r(r1) & logearn<=r(r2) & year==`yr'  //P50

	*

	qui _pctile logearn if year==`yr', p(74.8, 75.2)	
	qui replace percentile = 5 if logearn>=r(r1) & logearn<=r(r2) & year==`yr'  //P75

	*

	qui _pctile logearn if year==`yr', p(89.8, 90.2)	
	qui replace percentile = 6 if logearn>=r(r1) & logearn<=r(r2) & year==`yr'  //P90

	*

	qui _pctile logearn if year==`yr', p(94.8, 95.2)	
	qui replace percentile = 7 if logearn>=r(r1) & logearn<=r(r2) & year==`yr'  //P95

	*

	qui _pctile logearn if year==`yr', p(98.8, 99.2)	
	qui replace percentile = 8 if logearn>=r(r1) & logearn<=r(r2) & year==`yr'  //P99

}
*

*Male

forvalue yr=1993/2016 {

	qui _pctile logearn if year==`yr' & male==1, p(4.8, 5.2)	
	qui replace percentile_m = 1 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==1  //P5

	*

	qui _pctile logearn if year==`yr' & male==1, p(9.8, 10.2)	
	qui replace percentile_m = 2 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==1  //P10

	*

	qui _pctile logearn if year==`yr' & male==1, p(24.8, 25.2)	
	qui replace percentile_m = 3 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==1  //P25

	*

	qui _pctile logearn if year==`yr' & male==1, p(49.8, 50.2)	
	qui replace percentile_m = 4 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==1  //P50

	*

	qui _pctile logearn if year==`yr' & male==1, p(74.8, 75.2)	
	qui replace percentile_m = 5 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==1  //P75

	*

	qui _pctile logearn if year==`yr' & male==1, p(89.8, 90.2)	
	qui replace percentile_m = 6 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==1  //P90

	*

	qui _pctile logearn if year==`yr' & male==1, p(94.8, 95.2)	
	qui replace percentile_m = 7 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==1  //P95

	*

	qui _pctile logearn if year==`yr' & male==1, p(98.8, 99.2)	
	qui replace percentile_m = 8 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==1  //P99

}
*

*Female

forvalue yr=1993/2016 {

	qui _pctile logearn if year==`yr' & male==0, p(4.8, 5.2)	
	qui replace percentile_f = 1 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==0  //P5

	*

	qui _pctile logearn if year==`yr' & male==0, p(9.8, 10.2)	
	qui replace percentile_f = 2 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==0  //P10

	*

	qui _pctile logearn if year==`yr' & male==0, p(24.8, 25.2)	
	qui replace percentile_f = 3 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==0  //P25

	*

	qui _pctile logearn if year==`yr' & male==0, p(49.8, 50.2)	
	qui replace percentile_f = 4 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==0  //P50

	*

	qui _pctile logearn if year==`yr' & male==0, p(74.8, 75.2)	
	qui replace percentile_f = 5 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==0  //P75

	*

	qui _pctile logearn if year==`yr' & male==0, p(89.8, 90.2)	
	qui replace percentile_f = 6 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==0  //P90

	*

	qui _pctile logearn if year==`yr' & male==0, p(94.8, 95.2)	
	qui replace percentile_f = 7 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==0  //P95

	*

	qui _pctile logearn if year==`yr' & male==0, p(98.8, 99.2)	
	qui replace percentile_f = 8 if logearn>=r(r1) & logearn<=r(r2) & year==`yr' & male==0  //P99

}
*

*Whole population

preserve

keep if percentile != 0
replace ihours = 0 if empty_hours==1
replace total_hours=. if empty_hours==1

gen l_hours = log(total_hours)

collapse (sd) sd_l_hours=l_hours (p10) p10_hours=total_hours (p25) p25_hours=total_hours (mean) mean_hours=total_hours mean_inc=labor (p50) med_hours=total_hours med_inc=labor  (p75) p75_hours=total_hours (p90) p90_hours=total_hours  (sum) obs ihours, by(percentile year)

replace mean_inc = log(mean_inc)
replace med_inc = log(med_inc)

save "$maindir_replication${sep}Part_A${sep}dta${sep}hours_percentiles_logearn_all", replace

restore

*Male

preserve

keep if percentile_m != 0
replace ihours = 0 if empty_hours==1
replace total_hours=. if empty_hours==1

gen l_hours = log(total_hours)

collapse (sd) sd_l_hours=l_hours (p10) p10_hours=total_hours (p25) p25_hours=total_hours (mean) mean_hours=total_hours mean_inc=labor (p50) med_hours=total_hours med_inc=labor  (p75) p75_hours=total_hours (p90) p90_hours=total_hours  (sum) obs ihours, by(percentile_m year)

replace mean_inc = log(mean_inc)
replace med_inc = log(med_inc)

save "$maindir_replication${sep}Part_A${sep}dta${sep}hours_percentiles_logearn_male", replace

restore

*Female

preserve

keep if percentile_f != 0
replace ihours = 0 if empty_hours==1
replace total_hours=. if empty_hours==1

gen l_hours = log(total_hours)

collapse (sd) sd_l_hours=l_hours (p10) p10_hours=total_hours (p25) p25_hours=total_hours (mean) mean_hours=total_hours mean_inc=labor (p50) med_hours=total_hours med_inc=labor  (p75) p75_hours=total_hours (p90) p90_hours=total_hours  (sum) obs ihours, by(percentile_f year)

replace mean_inc = log(mean_inc)
replace med_inc = log(med_inc)

save "$maindir_replication${sep}Part_A${sep}dta${sep}hours_percentiles_logearn_female", replace

restore

}
*

********************************************
***Decomposition variance of log earnings***
********************************************

{

clear all
set more off
use "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_long"

keep if logearn!=.

*Hours and hourly wage

gen l_total_hours = log(total_hours)
gen l_wage = log(labor/total_hours)
gen l_product = l_total_hours * l_wage

keep if l_total_hours!=.

*Generate data

preserve

collapse (mean) logearn l_total_hours l_wage l_product (sd) v_logearn=logearn v_l_total_hours=l_total_hours v_l_wage=l_wage, by(year)

foreach var in v_logearn v_l_total_hours v_l_wage {
	replace `var' = `var' * `var'
}

gen cov_lhours_lwage = 2 * (l_product - l_total_hours * l_wage)
drop logearn l_total_hours l_wage l_product

save "$maindir_replication${sep}Part_A${sep}dta${sep}variance_decomposition_all", replace

restore

*

preserve

keep if male == 1

collapse (mean) logearn l_total_hours l_wage l_product (sd) v_logearn=logearn v_l_total_hours=l_total_hours v_l_wage=l_wage, by(year)

foreach var in v_logearn v_l_total_hours v_l_wage {
	replace `var' = `var' * `var'
}

gen cov_lhours_lwage = 2 * (l_product - l_total_hours * l_wage)
drop logearn l_total_hours l_wage l_product

save "$maindir_replication${sep}Part_A${sep}dta${sep}variance_decomposition_male", replace

restore

*

preserve

keep if male == 0

collapse (mean) logearn l_total_hours l_wage l_product (sd) v_logearn=logearn v_l_total_hours=l_total_hours v_l_wage=l_wage, by(year)

foreach var in v_logearn v_l_total_hours v_l_wage {
	replace `var' = `var' * `var'
}

gen cov_lhours_lwage = 2 * (l_product - l_total_hours * l_wage)
drop logearn l_total_hours l_wage l_product

save "$maindir_replication${sep}Part_A${sep}dta${sep}variance_decomposition_female", replace

}
*

***************************************
***Rank-rank correlation in earnings***
***************************************

{
clear all
set more off
use "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_long"

keep if logearn!=.
drop if year==.

replace statut_2012 = "P" if code_uu2010=="00851"

foreach var in permearn researn {
	sort year `var'
	by year : egen numobs=count(`var')
	by year : gen id=_n if `var'!=.

	by year : gen `var'rankt = floor(100*id/numobs)
	replace `var'rankt = `var'rankt+1 if `var'rankt!=100 & `var'rankt!=.
	drop numobs id
}

*

bys year: gen n = _n

egen id = group(idnr)
tsset id year

cap drop coef_*
cap drop se_*

foreach i in 1 5 {
	gen coef_res_`i' = .
	gen se_res_`i' = .
	gen coef_perm_`i' = .
	gen se_perm_`i' = .
*Men
	gen coef_res_`i'_m = .
	gen se_res_`i'_m = .
	gen coef_perm_`i'_m = .
	gen se_perm_`i'_m = .
*Women
	gen coef_res_`i'_f = .
	gen se_res_`i'_f = .
	gen coef_perm_`i'_f = .
	gen se_perm_`i'_f = .
*Age groups
	foreach var in young mid old {
		gen coef_res_`i'_`var' = .
		gen se_res_`i'_`var' = .
		gen coef_perm_`i'_`var' = .
		gen se_perm_`i'_`var' = .
	}
*Territories
	foreach var in P C B I R {
		gen coef_res_`i'_`var' = .
		gen se_res_`i'_`var' = .
		gen coef_perm_`i'_`var' = .
		gen se_perm_`i'_`var' = .
	}
}
*	
gen age = year - yob
gen age_gr = "young" if age>=25 & age<=34
replace age_gr = "mid" if age>=35 & age<=44
replace age_gr = "old" if age>=45 & age<=55

**5y rank-rank correlation

sort id year
forvalue yr =1993/2011 {

	qui reg F5.researnrankt researnrankt if year==`yr', r
	replace coef_res_5 = _b[researnrankt] if year==`yr' & n==1
	replace se_res_5 = _se[researnrankt] if year==`yr' & n==1
	
	*Gender 
	
	qui reg F5.researnrankt researnrankt if year==`yr' & male==0, r
	replace coef_res_5_f = _b[researnrankt] if year==`yr' & n==1
	replace se_res_5_f = _se[researnrankt] if year==`yr' & n==1

	qui reg F5.researnrankt researnrankt if year==`yr' & male==1, r
	replace coef_res_5_m = _b[researnrankt] if year==`yr' & n==1
	replace se_res_5_m = _se[researnrankt] if year==`yr' & n==1

	*Age

	foreach var in young mid old {
		qui reg F5.researnrankt researnrankt if year==`yr' & age_gr=="`var'", r
		replace coef_res_5_`var' = _b[researnrankt] if year==`yr' & n==1
		replace se_res_5_`var' = _se[researnrankt] if year==`yr' & n==1
	}
	
	*Territories
	
	foreach var in P C B I R {
		qui reg F5.researnrankt researnrankt if year==`yr' & statut_2012=="`var'", r
		replace coef_res_5_`var' = _b[researnrankt] if year==`yr' & n==1
		replace se_res_5_`var' = _se[researnrankt] if year==`yr' & n==1
	}
	
***Permanent Earnings

	qui reg F5.permearnrankt permearnrankt if year==`yr', r
	replace coef_perm_5 = _b[permearnrankt] if year==`yr' & n==1
	replace se_perm_5 = _se[permearnrankt] if year==`yr' & n==1
	
	*Gender
	
	qui reg F5.permearnrankt permearnrankt if year==`yr' & male==0, r
	replace coef_perm_5_f = _b[permearnrankt] if year==`yr' & n==1
	replace se_perm_5_f = _se[permearnrankt] if year==`yr' & n==1

	qui reg F5.permearnrankt permearnrankt if year==`yr' & male==1, r
	replace coef_perm_5_m = _b[permearnrankt] if year==`yr' & n==1
	replace se_perm_5_m = _se[permearnrankt] if year==`yr' & n==1	
	
	*Age
	
	foreach var in young mid old {
		qui reg F5.permearnrankt permearnrankt if year==`yr' & age_gr=="`var'", r
		replace coef_perm_5_`var' = _b[permearnrankt] if year==`yr' & n==1
		replace se_perm_5_`var' = _se[permearnrankt] if year==`yr' & n==1
	}
	
	*Territories
	
	foreach var in P C B I R {
		qui reg F5.permearnrankt permearnrankt if year==`yr' & statut_2012=="`var'", r
		replace coef_perm_5_`var' = _b[permearnrankt] if year==`yr' & n==1
		replace se_perm_5_`var' = _se[permearnrankt] if year==`yr' & n==1
	}
}
*

**1y rank-rank correlation

forvalue yr =1993/2015 {

	qui reg F1.researnrankt researnrankt if year==`yr', r
	replace coef_res_1 = _b[researnrankt] if year==`yr' & n==1
	replace se_res_1 = _se[researnrankt] if year==`yr' & n==1
	
	*Gender
	
	qui reg F1.researnrankt researnrankt if year==`yr' & male==0, r
	qui	replace coef_res_1_f = _b[researnrankt] if year==`yr' & n==1
	qui replace se_res_1_f = _se[researnrankt] if year==`yr' & n==1

	qui reg F1.researnrankt researnrankt if year==`yr' & male==1, r
	qui replace coef_res_1_m = _b[researnrankt] if year==`yr' & n==1
	qui replace se_res_1_m = _se[researnrankt] if year==`yr' & n==1

	*Age
	
	foreach var in young mid old {
		qui reg F1.researnrankt researnrankt if year==`yr' & age_gr=="`var'", r
		replace coef_res_1_`var' = _b[researnrankt] if year==`yr' & n==1
		replace se_res_1_`var' = _se[researnrankt] if year==`yr' & n==1
	}
	
	*Territories
	
	foreach var in P C B I R {
		qui reg F1.researnrankt researnrankt if year==`yr' & statut_2012=="`var'", r
		qui replace coef_res_1_`var' = _b[researnrankt] if year==`yr' & n==1
		qui replace se_res_1_`var' = _se[researnrankt] if year==`yr' & n==1
	}

***Permanent Earnings
	
	qui reg F1.permearnrankt permearnrankt if year==`yr', r
	qui replace coef_perm_1 = _b[permearnrankt] if year==`yr' & n==1
	qui replace se_perm_1 = _se[permearnrankt] if year==`yr' & n==1

	*Gender

	qui reg F1.permearnrankt permearnrankt if year==`yr' & male==0, r
	qui	replace coef_perm_1_f = _b[permearnrankt] if year==`yr' & n==1
	qui replace se_perm_1_f = _se[permearnrankt] if year==`yr' & n==1

	qui reg F1.permearnrankt permearnrankt if year==`yr' & male==1, r
	qui replace coef_perm_1_m = _b[permearnrankt] if year==`yr' & n==1
	qui replace se_perm_1_m = _se[permearnrankt] if year==`yr' & n==1

	*Age
	
	foreach var in young mid old {
		qui reg F1.permearnrankt permearnrankt if year==`yr' & age_gr=="`var'", r
		qui replace coef_perm_1_`var' = _b[permearnrankt] if year==`yr' & n==1
		qui replace se_perm_1_`var' = _se[permearnrankt] if year==`yr' & n==1
	}
	
	*Territories
	
	foreach var in P C B I R {
		qui reg F1.permearnrankt permearnrankt if year==`yr' & statut_2012=="`var'", r
		qui replace coef_perm_1_`var' = _b[permearnrankt] if year==`yr' & n==1
		qui replace se_perm_1_`var' = _se[permearnrankt] if year==`yr' & n==1
	}


}
*

keep if n==1

save "$maindir_replication${sep}Part_A${sep}dta${sep}panel_social_mobility", replace

}
*


***************************
***Panel unités urbaines***
***************************

***Data for Figure 16

{

clear all
set more off
use "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_long.dta"

drop if logearn==.
drop if code_uu2010==""
drop if year==.

replace statut_2012 = "P" if code_uu2010=="00851"

*Generate earnings variables based on the place of residence

foreach var in B C I P R {
	gen logearn_`var' = logearn if statut_2012=="`var'"
	gen labor_`var' = labor if statut_2012=="`var'"
	gen obs_`var' = (statut_2012=="`var'")
}

foreach i in 10 25 50 75 90 95 99 {
	global p`i' = "p`i'_B = logearn_B p`i'_C = logearn_C p`i'_I = logearn_I p`i'_P = logearn_P p`i'_R = logearn_R"
}

*

collapse (sum) obs_* (mean) labor_B labor_C labor_I labor_P labor_R (p10) $p10 (p25) $p25 (p50) $p50 (p75) $p75 (p90) $p90 (p95) $p95 (p99) $p99, by(year)

drop if year==.

*

foreach var in B C I P R {
	gen l_mean_`var' = log(labor_`var')
}
*Gap between (log) mean wage/percentiles in Paris and in other territories
foreach var in B C I R {
	foreach p in l_mean p10 p25 p50 p75 p90 p95 p99 {
		gen `p'_paris_`var' = `p'_P - `p'_`var'
	}
}
*Gaps normalized to 0 in 1993
foreach var in l_mean_paris_B p10_paris_B p25_paris_B p50_paris_B p75_paris_B p90_paris_B p95_paris_B p99_paris_B l_mean_paris_C p10_paris_C p25_paris_C p50_paris_C p75_paris_C p90_paris_C p95_paris_C p99_paris_C l_mean_paris_I p10_paris_I p25_paris_I p50_paris_I p75_paris_I p90_paris_I p95_paris_I p99_paris_I l_mean_paris_R p10_paris_R p25_paris_R p50_paris_R p75_paris_R p90_paris_R p95_paris_R p99_paris_R {
	qui: sum `var' if year==1993
	gen n_`var' = `var' - r(mean)
}

save "$maindir_replication${sep}Part_B${sep}dta${sep}panel_1993_2015_uu2010", replace
}
*

***********************************
***Share of minimum wage workers***
***********************************

***Data for figure 17

{
clear all
set more off
use "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_long.dta"

*

drop if logearn==.
drop if code_uu2010==""
drop if year==.

replace statut_2012 = "P" if code_uu2010=="00851"

*Hourly wage
*A lot of missing hours in 1993

drop if empty_hours==1
*

drop if total_hours > 2496 //48*52=2496 44*52=2288
*Exclude top .7%

drop if total_hours<1

gen hourly_wage = labor / total_hours


*Minimum (hourly) wage

global cpi2018 = 100		// Set the value of the CPI in 2018. 
matrix cpimat = /*  CPI between ${yrfirst}  and ${yrlast}
*/ (67.6747347, 69.29892833, 70.75420582, 71.88627312, 73.18022603, 74.64383055, 75.53955652, 75.99279386, 76.37275783, 77.67109471, /*
*/	78.91383223, 80.41319504, 82.10187214, 83.82601145, 85.25105365, 86.70032156, 88.00082638, 90.46484952, 90.55531437, 91.91364408, /*
*/  93.84383061, 95.72070722, 96.58219359, 97.06510456, 97.06510456, 97.25923476, 98.23182711, 100)'

matrix cpimat = cpimat/${cpi2018}


matrix minwg_C = /* Nominal minimum wage 1991-2018 in France
*/ (4.815102209, 5.099673708, 5.193938017, 5.365443162, 5.529325855,/*
*/  5.717600391, 5.88072084, 6.071282111, 6.169611728, 6.306815843,/*
*/  6.535489369, 6.75, 7.01, 7.4, 7.82, /*
*/  8.15, 8.355, 8.58, 8.725, 8.86, /*
*/  9.015833333, 9.31, 9.43, 9.53, 9.61, /*
*/  9.67, 9.76, 9.88)'

local yinic = 1993 - 1991 + 1	
local yend = 2016 - 1991 + 1

matrix mininc_C = minwg_C[`yinic'..`yend',1]		//
matrix cpimat_f = cpimat[`yinic'..`yend',1]		// 

														
matrix rmininc = J(2016-1993+1,1,0)
local i = 1
local tnum = 2016-1993+1
forvalues pp = 1(1)`tnum'{
	matrix rmininc[`i',1] = mininc_C[`i',1]/cpimat_f[`i',1]					
					// real min income threshold in local currency 
	local i = `i' + 1
}

*

gen minimum_wage = 0
gen minimum_wage_f = 0
gen minimum_wage_m = 0

global id = 0

forvalue yr = 1993/2016 {
	global id = $id + 1
	replace minimum_wage = 1 if year==`yr' & (hourly_wage > 0.95*rmininc[$id,1] & hourly_wage < 1.2*rmininc[$id,1])

	replace minimum_wage_f = (minimum_wage==1 & male==0)
	replace minimum_wage_m = (minimum_wage==1 & male==1)
}


*All
foreach var in B C I P R {
	gen minimum_wage_`var' = minimum_wage if statut_2012=="`var'"
	
	gen minimum_wage_f_`var' = minimum_wage_f if statut_2012=="`var'"
	gen minimum_wage_m_`var' = minimum_wage_m if statut_2012=="`var'"
	
	gen obs_`var' = 1 if statut_2012=="`var'"
	gen female_`var' = (male==0) if statut_2012=="`var'"
	gen male_`var' = (male==1) if statut_2012=="`var'"
}

**

collapse (sum) minimum_wage_B minimum_wage_f_B minimum_wage_m_B minimum_wage_C minimum_wage_f_C minimum_wage_m_C minimum_wage_I minimum_wage_f_I minimum_wage_m_I minimum_wage_P minimum_wage_f_P minimum_wage_m_P minimum_wage_R minimum_wage_f_R minimum_wage_m_R obs_B obs_C obs_I obs_P obs_R female_B male_B female_C male_C female_I male_I female_P male_P female_R male_R, by(year)

drop if year==.

foreach var in B C I P R {
	replace minimum_wage_`var' = 100 * minimum_wage_`var'/obs_`var'

	replace minimum_wage_f_`var' = 100 * minimum_wage_f_`var' / female_`var'
	replace minimum_wage_m_`var' = 100 * minimum_wage_m_`var' / male_`var'
}	

drop obs_*

save "$maindir_replication${sep}Part_B${sep}dta${sep}panel_min_wage_uu2010", replace

}
*

***************************
***Firm to firm mobility***
***************************

{

clear all
set more off
use "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_long.dta"

drop if code_uu2010==""
drop if year==.
drop if logearn==.

replace statut_2012 = "P" if code_uu2010=="00851"

bys idnr : egen yod = max(year)

gen exit = 0
replace exit = 1 if year==yod

sort idnr year

gen ft_fy = 0
replace ft_fy = 1 if ce=="C" & dp >=350

**Transitions based on main job between two consecutive years

by idnr: gen firm_switcher = 0 if private==1 & private[_n+1]==1 & siren!="" & siren[_n+1]!="" & year==year[_n+1] - 1 & exit==0
by idnr: replace firm_switcher = 1 if siren != siren[_n+1] & private==1 & private[_n+1]==1 & siren!="" & siren[_n+1]!="" & year==year[_n+1] - 1 & exit==0 

by idnr: gen plant_switcher = 0 if private==1 & private[_n+1]==1 & siret!="" & siret[_n+1]!="" & year==year[_n+1] - 1 & exit==0 
by idnr: replace plant_switcher = 1 if siret != siret[_n+1] & private==1 & private[_n+1]==1 & siret!="" & siret[_n+1]!="" & year==year[_n+1] - 1 & exit==0

*

by idnr: gen firm_switcher_ft = 0 if private==1 & private[_n+1]==1 & siren!="" & siren[_n+1]!="" & ft_fy==1 & year==year[_n+1] - 1 & exit==0
by idnr: replace firm_switcher_ft = 1 if siren != siren[_n+1] & private==1 & private[_n+1]==1 & siren!="" & siren[_n+1]!="" & ft_fy==1 & year==year[_n+1] - 1 & exit==0

by idnr: gen plant_switcher_ft = 0 if private==1 & private[_n+1]==1 & siret!="" & siret[_n+1]!="" & ft_fy==1 & year==year[_n+1] - 1 & exit==0
by idnr: replace plant_switcher_ft = 1 if siret != siret[_n+1] & private==1 & private[_n+1]==1 & siret!="" & siret[_n+1]!="" & ft_fy==1 & year==year[_n+1] - 1 & exit==0


**Transitions based on main job in december

by idnr: gen firm_switcher_dec = 0 if private==1 & private[_n+1]==1 & siren_dec!="" & siren_dec[_n+1]!="" & year==year[_n+1] - 1 & exit==0 
by idnr: replace firm_switcher_dec = 1 if siren_dec != siren_dec[_n+1] & private==1 & private[_n+1]==1 & siren_dec!="" & siren_dec[_n+1]!="" & year==year[_n+1] - 1 & exit==0

by idnr: gen plant_switcher_dec = 0 if private==1 & private[_n+1]==1 & siren_dec!="" & siret_dec[_n+1]!="" & year==year[_n+1] - 1 & exit==0
by idnr: replace plant_switcher_dec = 1 if siret_dec != siret_dec[_n+1] & private==1 & private[_n+1]==1 & siret_dec!="" & siret_dec[_n+1]!="" & year==year[_n+1] - 1 & exit==0

*

by idnr: gen firm_switcher_dec_ft = 0 if private==1 & private[_n+1]==1 & siren_dec!="" & siren_dec[_n+1]!="" & ft_fy==1 & year==year[_n+1] - 1 & exit==0 
by idnr: replace firm_switcher_dec_ft = 1 if siren_dec != siren_dec[_n+1] & private==1 & private[_n+1]==1 & siren_dec!="" & siren_dec[_n+1]!="" & ft_fy==1 & year==year[_n+1] - 1 & exit==0

by idnr: gen plant_switcher_dec_ft = 0 if private==1 & private[_n+1]==1 & siret_dec!="" & siret_dec[_n+1]!="" & ft_fy==1 & year==year[_n+1] - 1 & exit==0
by idnr: replace plant_switcher_dec_ft = 1 if siret_dec != siret_dec[_n+1] & private==1 & private[_n+1]==1 & siret_dec!="" & siret_dec[_n+1]!="" & ft_fy==1 & year==year[_n+1] - 1 & exit==0


***


foreach typo in B C I P R {
	foreach var in firm_switcher plant_switcher firm_switcher_ft plant_switcher_ft firm_switcher_dec plant_switcher_dec firm_switcher_dec_ft plant_switcher_dec_ft {
		gen `var'_`typo' = `var' if statut_2012=="`typo'"
	}
}

save "$maindir_replication${sep}Part_B${sep}dta${sep}panel_1993_2016_intermediate", replace

global switcher = "firm_switcher plant_switcher"
global switcher_ft = "firm_switcher_ft plant_switcher_ft"
global switcher_dec = "firm_switcher_dec plant_switcher_dec"
global switcher_dec_ft = "firm_switcher_dec_ft plant_switcher_dec_ft"

foreach typo in B C I P R {
	foreach var in switcher switcher_ft switcher_dec switcher_dec_ft {
		global `var' = "${`var'} firm_`var'_`typo' plant_`var'_`typo'"
	}
}

collapse (mean) $switcher $switcher_ft $switcher_dec $switcher_dec_ft , by(year)

foreach var in $switcher $switcher_ft $switcher_dec $switcher_dec_ft {
	replace `var' = 100 * `var'
}
*

save "$maindir_replication${sep}Part_B${sep}dta${sep}firm_switchers_1993_2016", replace

}
*

**********************************
***Mobility between territories***
**********************************

{

clear all
set more off
use "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_long"

drop if code_uu2010==""
drop if year==.
drop if logearn==.

replace statut_2012 = "P" if code_uu2010=="00851"
drop if statut_2012==""

bys idnr : egen yod = max(year)

gen exit = 0
replace exit = 1 if year==yod

sort idnr year

**Transitions based on main job

*Mobility by source of origin
foreach var1 in B C I R P {
	foreach var2 in B C I R P {
		by idnr: gen mob_`var1'_`var2' = 0 if statut_2012=="`var1'" & year==year[_n+1] - 1
		by idnr: replace mob_`var1'_`var2' = 1 if statut_2012=="`var1'" & statut_2012[_n+1]=="`var2'" & year==year[_n+1] - 1
	}
}
*
drop mob_B_B mob_C_C mob_I_I mob_R_R mob_P_P


*Overal migrations towards a given territory
foreach var1 in B C I R P {
	by idnr: gen mob_`var1' = 0 if statut_2012!="`var1'" & year==year[_n+1] - 1
	by idnr: replace mob_`var1' = 1 if statut_2012!="`var1'" & statut_2012[_n+1]=="`var1'" & year==year[_n+1] - 1
}

*Overal migrations from a given territory
foreach var1 in B C I R P {
	by idnr: gen mob_from_`var1' = 0 if statut_2012=="`var1'" & year==year[_n+1] - 1
	by idnr: replace mob_from_`var1' = 1 if statut_2012=="`var1'" & statut_2012[_n+1]!="`var1'" & year==year[_n+1] - 1
}


*Mobility by age group

gen age = year - yob + 1

by idnr: gen mobility_muni = 0 if year==year[_n+1] - 1
by idnr: replace mobility_muni = 1 if code_commune != code_commune[_n+1] & year==year[_n+1] - 1

gen mobility_muni_25_34 = mobility_muni if age>=25 & age<35
gen mobility_muni_35_44 = mobility_muni if age>=35 & age<45
gen mobility_muni_45_55 = mobility_muni if age>=45 & age<=55

gen mobility_muni_f = mobility_muni if male==0
gen mobility_muni_m = mobility_muni if male==1

*

merge m:1 code_commune using "$maindir_replication${sep}Data${sep}Nomenclatures${sep}ZE2010"
drop if _merge==2
drop _merge

bys idnr: gen mobility_CZ = 0 if year==year[_n+1] - 1
by idnr: replace mobility_CZ = 1 if code_ze2010 != code_ze2010[_n+1] & year==year[_n+1] - 1

gen mobility_CZ_25_34 = mobility_CZ if age>=25 & age<35
gen mobility_CZ_35_44 = mobility_CZ if age>=35 & age<45
gen mobility_CZ_45_55 = mobility_CZ if age>=45 & age<=55

gen mobility_CZ_f = mobility_CZ if male==0
gen mobility_CZ_m = mobility_CZ if male==1

**Percentile

foreach var in permearn researn {
	sort year `var'
	by year : egen numobs=count(`var')
	by year : gen id=_n if `var'!=.

	by year : gen `var'rankt = floor(100*id/numobs)
	replace `var'rankt = `var'rankt+1 if `var'rankt!=100 & `var'rankt!=.
	drop numobs id
}

*Mobility towards a given area

foreach var1 in B C I R P {
	gen permrankt_mob_`var1' = permearnrankt if mob_`var1' == 1
	gen resrankt_mob_`var1' = researnrankt if mob_`var1' == 1
}
*

*Mobility from a given area

foreach var1 in B C I R P {
	gen permrankt_mob_from_`var1' = permearnrankt if mob_from_`var1' == 1
	gen resrankt_mob_from_`var1' = researnrankt if mob_from_`var1' == 1
}
*

save "$maindir_replication${sep}Part_B${sep}dta${sep}mobility_territories_intermediate.dta", replace

global mobility1 = "mob_B mob_C mob_I mob_R mob_P mob_from_B mob_from_C mob_from_I mob_from_R mob_from_P mobility_muni_f mobility_muni_m mobility_CZ_f mobility_CZ_m"
global mobility2 = "mob_B_C mob_B_I mob_B_R mob_B_P mob_C_B mob_C_I mob_C_R mob_C_P mob_I_B mob_I_C mob_I_R mob_I_P mob_R_B mob_R_C mob_R_I mob_R_P mob_P_B mob_P_C mob_P_I mob_P_R"
global mobility3 = "permrankt_mob_B resrankt_mob_B permrankt_mob_C resrankt_mob_C permrankt_mob_I resrankt_mob_I permrankt_mob_R resrankt_mob_R permrankt_mob_P resrankt_mob_P permrankt_mob_from_B resrankt_mob_from_B permrankt_mob_from_C resrankt_mob_from_C permrankt_mob_from_I resrankt_mob_from_I permrankt_mob_from_R resrankt_mob_from_R permrankt_mob_from_P resrankt_mob_from_P"
global mobility4 = "mobility_CZ mobility_CZ_25_34 mobility_CZ_35_44 mobility_CZ_45_55 mobility_muni mobility_muni_25_34 mobility_muni_35_44 mobility_muni_45_55"


collapse (mean) $mobility1 $mobility2 $mobility3 $mobility4, by(year)

foreach var in $mobility1 $mobility2 $mobility4 {
	replace `var' = 100 * `var'
}

save "$maindir_replication${sep}Part_B${sep}dta${sep}mobility_territories.dta", replace


}
*


********************************************
***Earnings growth for movers and stayers***
********************************************

{

clear all
set more off
use "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_long"

drop if code_uu2010==""
drop if statut_2012==""
drop if year==.
replace statut_2012 = "P" if code_uu2010=="00851"
drop if logearn==.

merge m:1 code_commune using "$maindir_replication${sep}Data${sep}Nomenclatures${sep}ZE2010"
drop if _merge==2
drop _merge

sort idnr year

***Movers from Cities in province to Paris

*T+1
by idnr: gen mover_Prov_to_P_1y = 0 if statut_2012!="P" & statut_2012!="R" & year==year[_n+1] - 1
by idnr: replace mover_Prov_to_P_1y = 1 if statut_2012!="P" & statut_2012!="R" & statut_2012[_n+1]=="P" & year==year[_n+1] - 1

*T+5
gen mover_Prov_to_P_5y = .
forvalue i = 1/5 {
	by idnr: replace mover_Prov_to_P_5y = 0 if statut_2012!="P" & statut_2012!="R" & year==year[_n+`i'] - 5
	by idnr: replace mover_Prov_to_P_5y = 1 if statut_2012!="P" & statut_2012!="R" & statut_2012[_n+`i']=="P" & year==year[_n+`i'] - 5
}
*

***Movers from Cities in province to Rural

*T+1
by idnr: gen mover_Prov_to_R_1y = 0 if statut_2012!="P" & statut_2012!="R" & year==year[_n+1] - 1
by idnr: replace mover_Prov_to_R_1y = 1 if statut_2012!="P" & statut_2012!="R" & statut_2012[_n+1]=="R" & year==year[_n+1] - 1

*T+5
gen mover_Prov_to_R_5y = .
forvalue i = 1/5 {
	by idnr: replace mover_Prov_to_R_5y = 0 if statut_2012!="P" & statut_2012!="R" & year==year[_n+`i'] - 5
	by idnr: replace mover_Prov_to_R_5y = 1 if statut_2012!="P" & statut_2012!="R" & statut_2012[_n+`i']=="R" & year==year[_n+`i'] - 5
}
*


***Movers from Rural to Paris

*T+1
by idnr: gen mover_R_to_P_1y = 0 if statut_2012=="R" & year==year[_n+1] - 1
by idnr: replace mover_R_to_P_1y = 1 if statut_2012=="R" & statut_2012[_n+1]=="P" & year==year[_n+1] - 1

*T+5
gen mover_R_to_P_5y = .
forvalue i = 1/5 {
	by idnr: replace mover_R_to_P_5y = 0 if statut_2012=="R" & year==year[_n+`i'] - 5
	by idnr: replace mover_R_to_P_5y = 1 if statut_2012=="R" & statut_2012[_n+`i']=="P" & year==year[_n+`i'] - 5
}
*

***Movers from Rural to Cities in province

*T+1
by idnr: gen mover_R_to_Prov_1y = 0 if statut_2012=="R" & year==year[_n+1] - 1
by idnr: replace mover_R_to_Prov_1y = 1 if statut_2012=="R" & statut_2012[_n+1]!="P" & statut_2012[_n+1]!="R" & year==year[_n+1] - 1

*T+5
gen mover_R_to_Prov_5y = .
forvalue i = 1/5 {
	by idnr: replace mover_R_to_Prov_5y = 0 if statut_2012=="R" & year==year[_n+`i'] - 5
	by idnr: replace mover_R_to_Prov_5y = 1 if statut_2012=="R" & statut_2012[_n+`i']!="P" & statut_2012[_n+`i']!="R" & year==year[_n+`i'] - 5
}
*


***Movers from Paris to Cities in province

*T+1
by idnr: gen mover_P_to_Prov_1y = 0 if statut_2012=="P" & year==year[_n+1] - 1
by idnr: replace mover_P_to_Prov_1y = 1 if statut_2012=="P" & statut_2012[_n+1]!="P" & statut_2012[_n+1]!="R" & year==year[_n+1] - 1

*T+5
gen mover_P_to_Prov_5y=.
forvalue i = 1/5 {
	by idnr: replace mover_P_to_Prov_5y = 0 if statut_2012=="P" & year==year[_n+`i'] - 5
	by idnr: replace mover_P_to_Prov_5y = 1 if statut_2012=="P" & statut_2012[_n+`i']!="P" & statut_2012[_n+`i']!="R" & year==year[_n+`i'] - 5
}
*

***Movers from Paris to Rural

*T+1
by idnr: gen mover_P_to_R_1y = 0 if statut_2012=="P" & year==year[_n+1] - 1
by idnr: replace mover_P_to_R_1y = 1 if statut_2012=="P" & statut_2012[_n+1]=="R" & year==year[_n+1] - 1

*T+5
gen mover_P_to_R_5y=.
forvalue i = 1/5 {
	by idnr: replace mover_P_to_R_5y = 0 if statut_2012=="P" & year==year[_n+`i'] - 5
	by idnr: replace mover_P_to_R_5y = 1 if statut_2012=="P" & statut_2012[_n+`i']=="R" & year==year[_n+`i'] - 5
}
*


***Movers Province-Province (change CZ)

*T+1
bys idnr: gen mover_Prov_Prov_1y = 0 if statut_2012!="P" & statut_2012!="R" & year==year[_n+1] - 1
by idnr: replace mover_Prov_Prov_1y = 1 if statut_2012!="P" & statut_2012!="R" & statut_2012[_n+1]!="P" & statut_2012[_n+1]!="R" & code_ze2010!=code_ze2010[_n+1] & year==year[_n+1] - 1

*T+5
gen mover_Prov_Prov_5y=.
forvalue i = 1/5 {
	by idnr: replace mover_Prov_Prov_5y = 0 if statut_2012!="P" & statut_2012!="R" & year==year[_n+`i'] - 5
	by idnr: replace mover_Prov_Prov_5y = 1 if statut_2012!="P" & statut_2012!="R" & statut_2012[_n+`i']!="P" & statut_2012[_n+`i']!="R" & code_ze2010!=code_ze2010[_n+`i'] & year==year[_n+`i'] - 5
}
*

***Stayers in Paris

*Observed at least 3 consecutive years in Paris
by idnr: gen stayers_P_1y = 0 if statut_2012[_n-1]=="P" & statut_2012=="P" & year==year[_n+1] - 1 & year==year[_n-1] + 1
by idnr: replace stayers_P_1y = 1 if statut_2012[_n-1]=="P" & statut_2012=="P" & statut_2012[_n+1]=="P" & year==year[_n+1] - 1 & year==year[_n-1] + 1

*Paris in T-1, T and T+5
gen stayers_P_5y=.
forvalue i = 1/5 {
	by idnr: replace stayers_P_5y = 0 if statut_2012[_n-1]=="P" & statut_2012=="P" & year==year[_n+`i'] - 5 & year==year[_n-1] + 1
	by idnr: replace stayers_P_5y = 1 if statut_2012[_n-1]=="P" & statut_2012=="P" & statut_2012[_n+`i']=="P" & year==year[_n+`i'] - 5 & year==year[_n-1] + 1
}
*

***Stayers in Province

*Observed at least 3 consecutive years in Province
by idnr: gen stayers_Prov_1y = 0 if statut_2012[_n-1]!="P" & statut_2012!="P" & statut_2012[_n-1]!="R" & statut_2012!="R" & year==year[_n+1] - 1 & year==year[_n-1] + 1
by idnr: replace stayers_Prov_1y = 1 if statut_2012[_n-1]!="P" & statut_2012!="P" & statut_2012[_n-1]!="R" & statut_2012!="R" & statut_2012[_n+1]!="P" & statut_2012[_n+1]!="R" & year==year[_n+1] - 1 & year==year[_n-1] + 1

*Observed at least 3 consecutive years  in Province within the same CZ
by idnr: gen stayers_Prov_nmove_1y = 0 if statut_2012[_n-1]!="P" & statut_2012!="P" & statut_2012[_n-1]!="R" & statut_2012!="R" & year==year[_n+1] - 1 & year==year[_n-1] + 1
by idnr: replace stayers_Prov_nmove_1y = 1 if statut_2012[_n-1]!="P" & statut_2012!="P" & statut_2012[_n-1]!="R" & statut_2012!="R" & statut_2012[_n+1]!="P" & statut_2012[_n+1]!="R" & code_ze2010==code_ze2010[_n+1] & year==year[_n+1] - 1 & year==year[_n-1] + 1


*Province in T-1, T and T+5
gen stayers_Prov_5y=.
gen stayers_Prov_nmove_5y=.
forvalue i = 1/5 {
	by idnr: replace stayers_Prov_5y = 0 if statut_2012[_n-1]!="P" & statut_2012!="P" & statut_2012[_n-1]!="R" & statut_2012!="R" & year==year[_n+`i'] - 5 & year==year[_n-1] + 1
	by idnr: replace stayers_Prov_5y = 1 if statut_2012[_n-1]!="P" & statut_2012!="P" & statut_2012[_n-1]!="R" & statut_2012!="R" & statut_2012[_n+`i']!="P" & statut_2012[_n+`i']!="R" & year==year[_n+`i'] - 5 & year==year[_n-1] + 1

	by idnr: replace stayers_Prov_nmove_5y = 0 if statut_2012[_n-1]!="P" & statut_2012!="P" & statut_2012[_n-1]!="R" & statut_2012!="R" & year==year[_n+`i'] - 5 & year==year[_n-1] + 1
	by idnr: replace stayers_Prov_nmove_5y = 1 if statut_2012[_n-1]!="P" & statut_2012!="P" & statut_2012[_n+`i']!="P" & statut_2012[_n-1]!="R" & statut_2012!="R" & statut_2012[_n+`i']!="R" & code_ze2010==code_ze2010[_n+`i'] & year==year[_n+`i'] - 5 & year==year[_n-1] + 1
}
*

***Stayers Rural

*Observed at least 3 consecutive years in Rural territories
by idnr: gen stayers_R_1y = 0 if statut_2012[_n-1]=="R" & statut_2012=="R" & year==year[_n+1] - 1 & year==year[_n-1] + 1
by idnr: replace stayers_R_1y = 1 if statut_2012[_n-1]=="R" & statut_2012=="R" & statut_2012[_n+1]=="R" & year==year[_n+1] - 1 & year==year[_n-1] + 1

*Rural in T-1, T and T+5
gen stayers_R_5y=.
forvalue i = 1/5 {
	by idnr: replace stayers_R_5y = 0 if statut_2012[_n-1]=="R" & statut_2012=="R" & year==year[_n+`i'] - 5 & year==year[_n-1] + 1
	by idnr: replace stayers_R_5y = 1 if statut_2012[_n-1]=="R" & statut_2012=="R" & statut_2012[_n+`i']=="R" & year==year[_n+`i'] - 5 & year==year[_n-1] + 1
}
*

**

save "$maindir_replication${sep}Part_B${sep}dta${sep}growth_stayers_movers.dta", replace


***Density Data

clear all
set more off
use "$maindir_replication${sep}Part_B${sep}dta${sep}growth_stayers_movers.dta"

foreach v in 1 5 { //1 5
	
	local id = 0
		
	foreach var in mover_Prov_to_P_`v'y  mover_Prov_to_R_`v'y  mover_R_to_P_`v'y  mover_R_to_Prov_`v'y  mover_P_to_Prov_`v'y  mover_P_to_R_`v'y  mover_Prov_Prov_`v'y  stayers_P_`v'y  stayers_Prov_nmove_`v'y  stayers_R_`v'y { 
		
		preserve 
		
		local id = `id' + 1
		
		kdensity researn`v'F if `var'==1, generate(val_researn`v'F_`id' den_researn`v'F_`id') nograph n(400)
		keep val_researn`v'F_`id' den_researn`v'F_`id'
		qui: drop if val_researn`v'F_`id' == . 		

		gen index  = _n
		gen `var' = 1
		
		order index val_researn`v'F_`id' den_researn`v'F_`id'
		save "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_`var'_hist.dta", replace	

		restore
	
	}
}
*

***Merge data

foreach v in 1 5 {
	clear all
	set more off

	use "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_mover_Prov_to_P_`v'y_hist.dta"
	merge 1:1 index using "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_mover_Prov_to_R_`v'y_hist.dta", nogen
	merge 1:1 index using "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_mover_R_to_P_`v'y_hist.dta", nogen
	merge 1:1 index using "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_mover_R_to_Prov_`v'y_hist.dta", nogen
	merge 1:1 index using "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_mover_P_to_Prov_`v'y_hist.dta", nogen
	merge 1:1 index using "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_mover_P_to_R_`v'y_hist.dta", nogen
	merge 1:1 index using "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_mover_Prov_Prov_`v'y_hist.dta", nogen
	
	merge 1:1 index using "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_stayers_P_`v'y_hist.dta", nogen
	merge 1:1 index using "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_stayers_Prov_nmove_`v'y_hist.dta", nogen
	merge 1:1 index using "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_stayers_R_`v'y_hist.dta", nogen
	
	save "$maindir_replication${sep}Part_B${sep}dta${sep}hist_`v'y", replace
	
	erase "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_mover_Prov_to_P_`v'y_hist.dta"
	erase "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_mover_Prov_to_R_`v'y_hist.dta"
	erase "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_mover_R_to_P_`v'y_hist.dta"
	erase "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_mover_R_to_Prov_`v'y_hist.dta"
	erase "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_mover_P_to_Prov_`v'y_hist.dta"
	erase "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_mover_P_to_R_`v'y_hist.dta"
	erase "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_mover_Prov_Prov_`v'y_hist.dta"
	erase "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_stayers_P_`v'y_hist.dta"
	erase "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_stayers_Prov_nmove_`v'y_hist.dta"
	erase "$maindir_replication${sep}Part_B${sep}dta${sep}researn`v'F_stayers_R_`v'y_hist.dta"	
}
*

}
*


************************************
***Between Urban Areas Inequality***
************************************

{
clear all
set more off
use "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_long" if logearn!=. , clear 

drop if inlist(code_au2010, "", "000", "997", "998")

keep if inlist(year,2000,2001,2002,2014,2015,2016)

gen ag = year-yob+1
tab ag, gen(agedum)
drop agedum1
tab educ, gen(dip)
drop dip1

replace pcs4 = "" if inlist(pcs4,"000Z", "9999", "ZZZZ") 

replace apet2 = apet if apet2==""

gen l_total_hours = log(total_hours)
replace l_total_hours = 0 if l_total_hours==.

gen l_size_et = log(nbsa_et)
gen l_size_en = log(nbsa_en)


******

*No controls: logearn

*Individual caracteristics: Gender / Age / Diploma

gen researn_a = .

foreach yr in 2000 2001 2002 2014 2015 2016 { 
	qui reg logearn agedum* dip* if male==1 & year==`yr', r
	predict temp_m if e(sample)==1 & year==`yr', resid

	qui reg logearn agedum* dip* if male==0 & year==`yr', r
	predict temp_f if e(sample)==1 & year==`yr', resid	

	replace researn_a = temp_m if male==1 & year==`yr'
	replace researn_a = temp_f if male==0 & year==`yr'
	drop temp_m temp_f
}
*

*Individual + job caracteristics: Gender / Age / Diploma + hours / occupation code

gen researn_b = .

foreach yr in 2000 2001 2002 2014 2015 2016 { 
	qui reghdfe logearn agedum* dip* l_total_hours i.empty_hours if male==1 & year==`yr', a(cs2) resid
	predict temp_m if e(sample)==1 & year==`yr', resid

	qui reghdfe logearn agedum* dip* l_total_hours i.empty_hours if male==0 & year==`yr', a(cs2) resid
	predict temp_f if e(sample)==1 & year==`yr', resid	

	replace researn_b = temp_m if male==1 & year==`yr'
	replace researn_b = temp_f if male==0 & year==`yr'
	drop temp_m temp_f
}
*

*Individual + job + firm caracteristics (industry + size): researn6
*Age + Industry 4d + education + hours + occ + firm size

gen researn_c = .

foreach yr in 2000 2001 2002 2014 2015 2016 { 
	qui reghdfe logearn agedum* dip* l_total_hours i.empty_hours l_size_en if male==1 & year==`yr', a(apet2 cs2) resid
	predict temp_m if e(sample)==1 & year==`yr', resid

	qui reghdfe logearn agedum* dip* l_total_hours i.empty_hours l_size_en if male==0 & year==`yr', a(apet2 cs2) resid
	predict temp_f if e(sample)==1 & year==`yr', resid	

	replace researn_c = temp_m if male==1 & year==`yr'
	replace researn_c = temp_f if male==0 & year==`yr'
	drop temp_m temp_f
}
*


*
foreach var in 10 25 50 75 90 95 99 {
	global p`var' = "p`var'_1=logearn p`var'_2=researn_a p`var'_3=researn_b p`var'_4=researn_c" 
}

*

cap gen obs = 1

gen year_mean = 2001 if year<=2002
replace year_mean = 2015 if year>=2014


collapse (sum) obs (mean) labor (p10) $p10 (p25) $p25 (p50) $p50 (p75) $p75 (p90) $p90 (p95) $p95 (p99) $p99 , by(year_mean code_au2010 au2010)

gen mean = log(labor)

*Rank by size in 2015

merge m:1 code_au2010 using "$nomenclatures${sep}pop_au2010_2015.dta"
drop if _merge==2
drop _merge

sort year_mean census_population_2015
by year_mean : gen rank = 769 - _n

sort year_mean rank

*
foreach var in mean p10_1 p10_2 p10_3 p10_4 p25_1 p25_2 p25_3 p25_4 p50_1 p50_2 p50_3 p50_4 p75_1 p75_2 p75_3 p75_4 p90_1 p90_2 p90_3 p90_4 p95_1 p95_2 p95_3 p95_4 p99_1 p99_2 p99_3 p99_4 {
	gen n_`var' = 0
}
*
foreach yr in 2001 2015 {
	foreach var in mean p10_1 p10_2 p10_3 p10_4 p25_1 p25_2 p25_3 p25_4 p50_1 p50_2 p50_3 p50_4 p75_1 p75_2 p75_3 p75_4 p90_1 p90_2 p90_3 p90_4 p95_1 p95_2 p95_3 p95_4 p99_1 p99_2 p99_3 p99_4 {
		qui: sum `var' if rank == 1 & year_mean==`yr'
		replace n_`var' =  `var' - r(mean) if year_mean==`yr'
	}
}
save "$maindir_replication${sep}Part_B${sep}dta${sep}wage_panel_edp_2001_2016", replace


}
*


*****************
***Convergence***
*****************

{
clear all
set more off
use "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_long.dta"

drop if code_au2010==""
keep if logearn!=.

gen obs=1

keep if inlist(year,1995,2000,2005,2010,2015)

collapse (sum) pop=obs (mean) labor (p50) p50=logearn, by(code_au2010 year)

drop if code_au2010=="" | code_au2010=="000" | code_au2010=="997" | code_au2010=="998" | code_au2010=="999"

gen l_mean_ = log(labor)
rename p50 l_p50_
rename pop pop_
rename labor labor_

reshape wide pop_ labor_ l_p50_ l_mean_, i(code_au2010) j(year)

*Every 5y

foreach var in mean p50 {
	forvalue yr=1995(5)2010 {
		local yrp = `yr' + 5

		gen `var'_growth_`yr'_`yrp' = .
		replace `var'_growth_`yr'_`yrp' = exp((1/5)*(l_`var'_`yrp'-l_`var'_`yr')) - 1 
		replace `var'_growth_`yr'_`yrp' = `var'_growth_`yr'_`yrp' * 100 //in %
	}
}
*
***

foreach var in mean p50 {
	gen `var'_growth_1995_2015 = .
	replace `var'_growth_1995_2015 = exp((1/20)*(l_`var'_2015-l_`var'_1995)) - 1
	replace `var'_growth_1995_2015 = `var'_growth_1995_2015 * 100 //in %
}


*Size in 2015 

merge m:1 code_au2010 using "$maindir_replication${sep}Data${sep}Nomenclatures${sep}pop_au2010_2015.dta"
drop if _merge==2
drop _merge year

sort census_population_2015
gen rank = 769 - _n
gen lrank = log(rank)
gen l_population_2015 = log(census_population_2015)

sort rank

save "$maindir_replication${sep}Part_B${sep}dta${sep}convergence", replace

}
*


************************
***Panel by Territory***
************************

*Generates one dataset for each territory: Paris, Central municipalities, Suburbs, Remote municipalities, Rural municipalities

{
clear all
set more off 
use "$processing${sep}panel_dads_edp_1991_2016_extended.dta"

drop if code_uu2010==""
replace statut_2012 = "P" if code_uu2010=="00851" //Paris

keep year b_year idnr personid yod ag male wage_inc educ statut_2012

*

preserve

keep if statut_2012 == "P" 

save "$maindir_replication${sep}Part_B${sep}local${sep}paris${sep}dta${sep}panel_dads_edp_1991_2016.dta", replace

restore
*
preserve

keep if statut_2012 == "C" 

save "$maindir_replication${sep}Part_B${sep}local${sep}central${sep}dta${sep}panel_dads_edp_1991_2016.dta", replace

restore
*
preserve

keep if statut_2012 == "B" 

save "$maindir_replication${sep}Part_B${sep}local${sep}suburbs${sep}dta${sep}panel_dads_edp_1991_2016.dta", replace

restore
*
preserve

keep if statut_2012 == "I" 

save "$maindir_replication${sep}Part_B${sep}local${sep}remote${sep}dta${sep}panel_dads_edp_1991_2016.dta", replace

restore
*

keep if statut_2012 == "R" 

save "$maindir_replication${sep}Part_B${sep}local${sep}rural${sep}dta${sep}panel_dads_edp_1991_2016.dta", replace

}
*


*********************
***Panel local CPI*** 
*********************

***Data for Appendix Figure H.2

{

***Size of Urban Units
*Local CPI depends on the size of the cities

{
clear all
set more off
use "$nomenclatures${sep}population_1968_2015_final.dta"

keep code_commune_initial code_commune_1990 code_commune_2010 commune census_population_1999
rename code_commune_2010 code_commune

merge m:1 code_commune using "$nomenclatures${sep}UU2010_final.dta"
drop if _merge==2 | _merge==1
drop _merge

collapse (sum) census_population_1999 , by(code_uu2010)

save "$maindir_replication${sep}Part_B${sep}dta${sep}size_uu", replace
}
*

***Inequality with national vs. local CPI

{

clear all
set more off
use "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_long.dta"

drop if logearn==.
drop if code_uu2010==""
drop if year==.

*

merge m:1 code_uu2010 using "$maindir_replication${sep}Part_B${sep}dta${sep}size_uu.dta"
drop if _merge==2
drop _merge

gen group = 0
replace group = 1 if statut_2012=="R" //rural areas
replace group = 2 if census_population_1999<20000 & statut_2012!="R" //cities smaller than 20k inhaitants
replace group = 3 if census_population_1999>=20000 & census_population_1999<100000 & statut_2012!="R" //cities between 20k-100k
replace group = 4 if census_population_1999>=100000 & census_population_1999!=. & statut_2012!="R" //cities bigger than 100k (wo Paris)
replace group = 5 if code_uu2010=="00851" //UU Paris (wo Paris)
replace group = 6 if code_commune=="75056" //Paris


***National CPI
preserve

forvalue i = 1/6 {
	gen logearn_`i' = logearn if group==`i'
	gen labor_`i' = labor if group==`i'
	gen obs_`i' = (group==`i')
}

foreach i in 10 25 50 75 90 95 99 {
	global p`i' = "p`i'_1 = logearn_1 p`i'_2 = logearn_2 p`i'_3 = logearn_3 p`i'_4 = logearn_4 p`i'_5 = logearn_5 p`i'_6 = logearn_6"
}

*

collapse (sum) obs_* (mean) labor_1 labor_2 labor_3 labor_4 labor_5 labor_6 (p10) $p10 (p25) $p25 (p50) $p50 (p75) $p75 (p90) $p90 (p95) $p95 (p99) $p99, by(year)  

drop if year==.

*

forvalue i = 1/6 {
	gen l_mean_`i' = log(labor_`i')
}
*
foreach i in 1 2 3 4 5 {
	foreach p in l_mean p10 p25 p50 p75 p90 p95 p99 {
		gen `p'_paris_`i' = `p'_6 - `p'_`i'
	}
}
*
foreach var in l_mean_paris_1 p10_paris_1 p25_paris_1 p50_paris_1 p75_paris_1 p90_paris_1 p95_paris_1 p99_paris_1 l_mean_paris_2 p10_paris_2 p25_paris_2 p50_paris_2 p75_paris_2 p90_paris_2 p95_paris_2 p99_paris_2 l_mean_paris_3 p10_paris_3 p25_paris_3 p50_paris_3 p75_paris_3 p90_paris_3 p95_paris_3 p99_paris_3 l_mean_paris_4 p10_paris_4 p25_paris_4 p50_paris_4 p75_paris_4 p90_paris_4 p95_paris_4 p99_paris_4 l_mean_paris_5 p10_paris_5 p25_paris_5 p50_paris_5 p75_paris_5 p90_paris_5 p95_paris_5 p99_paris_5 {
	qui: sum `var' if year==1998
	gen n_`var' = `var' - r(mean)
}

compress
save "$maindir_replication${sep}Part_B${sep}dta${sep}panel_1993_2015_size", replace
restore


***Local CPI

drop if year<1998
drop if year>2012

*Local CPI

global local_cpi_1998 = 100		// Set the value of the CPI in 1998. 

matrix local_cpi_1 = /*  CPI rural
*/	(100, 100.57, 102.76, 104.36, 106.21, 108.49, 111.02, 113.3, 115.29, 117.04, 120.85, 120.42, 122.62, 125.65, 128.31)'

matrix local_cpi_2 = /*  CPI <20k
*/	(100, 100.54, 102.45, 104.16, 106.07, 108.3, 110.67, 112.71, 114.58, 116.2, 119.63, 119.41, 121.35, 124.07, 126.53)'

matrix local_cpi_3 = /*  CPI 20k-100k
*/	(100, 100.57, 102.31, 104.05, 106.02, 108.3, 110.72, 112.67, 114.61, 116.32, 119.64, 119.77, 121.66, 124.28, 126.8)'

matrix local_cpi_4 = /*  CPI >100k
*/	(100, 100.58, 102.1, 103.87, 105.91, 108.17, 110.46, 112.31, 114.2, 115.9, 119.01, 119.35, 121.02, 123.43, 125.81)'

matrix local_cpi_5 = /*  UU Paris outside of the municipality of Paris
*/	(100, 100.42, 101.54, 103.12, 105.23, 107.29, 109.33, 110.97, 112.83, 114.63, 117.5, 118.06, 119.52, 121.74, 123.98)'

matrix local_cpi_6 = /*  municipality of Paris
*/	(100, 100.5, 101.22, 102.78, 105.06, 107.23, 109.23, 110.75, 112.48, 114.16, 116.51, 117.42, 118.61, 120.54, 122.77)'

forvalue i=1/6 {
	matrix local_cpi_`i' = local_cpi_`i'/${local_cpi_1998}
}

***National CPI

global cpi2018 = 100		// Set the value of the CPI in 2018. 
matrix cpimat = /*  CPI between ${yrfirst}  and ${yrlast}
*/ (67.6747347, 69.29892833, 70.75420582, 71.88627312, 73.18022603, 74.64383055, 75.53955652, 75.99279386, 76.37275783, 77.67109471, /*
*/	78.91383223, 80.41319504, 82.10187214, 83.82601145, 85.25105365, 86.70032156, 88.00082638, 90.46484952, 90.55531437, 91.91364408, /*
*/  93.84383061, 95.72070722, 96.58219359, 97.06510456, 97.06510456, 97.25923476, 98.23182711, 100)'

matrix cpimat = cpimat/${cpi2018}

***

forvalue yr = 1998/2012 {
	local local_cpi_index = `yr'-1998+1
	local cpi_index = `yr'-1991+1
	
	forvalue i = 1/6 {
		replace labor = cpimat[`cpi_index',1] * labor / local_cpi_`i'[`local_cpi_index',1] if year==`yr' & group==`i'
	}
}

*

forvalue i = 1/6 {
	gen logearn_`i' = log(labor) if group==`i'
	gen labor_`i' = labor if group==`i'
	gen obs_`i' = (group==`i')
}

foreach i in 10 25 50 75 90 95 99 {
	global p`i' = "p`i'_1 = logearn_1 p`i'_2 = logearn_2 p`i'_3 = logearn_3 p`i'_4 = logearn_4 p`i'_5 = logearn_5 p`i'_6 = logearn_6"
}

*

collapse (sum) obs_* (mean) labor_1 labor_2 labor_3 labor_4 labor_5 labor_6 (p10) $p10 (p25) $p25 (p50) $p50 (p75) $p75 (p90) $p90 (p95) $p95 (p99) $p99, by(year)  

drop if year==.

*

forvalue i = 1/6 {
	gen l_mean_`i' = log(labor_`i')
}
*
foreach i in 1 2 3 4 5 {
	foreach p in l_mean p10 p25 p50 p75 p90 p95 p99 {
		gen `p'_paris_`i' = `p'_6 - `p'_`i'
	}
}
*
foreach var in l_mean_paris_1 p10_paris_1 p25_paris_1 p50_paris_1 p75_paris_1 p90_paris_1 p95_paris_1 p99_paris_1 l_mean_paris_2 p10_paris_2 p25_paris_2 p50_paris_2 p75_paris_2 p90_paris_2 p95_paris_2 p99_paris_2 l_mean_paris_3 p10_paris_3 p25_paris_3 p50_paris_3 p75_paris_3 p90_paris_3 p95_paris_3 p99_paris_3 l_mean_paris_4 p10_paris_4 p25_paris_4 p50_paris_4 p75_paris_4 p90_paris_4 p95_paris_4 p99_paris_4 l_mean_paris_5 p10_paris_5 p25_paris_5 p50_paris_5 p75_paris_5 p90_paris_5 p95_paris_5 p99_paris_5 {
	qui: sum `var' if year==1998
	gen n_`var' = `var' - r(mean)
}


save "$maindir_replication${sep}Part_B${sep}dta${sep}panel_1993_2015_size_local_cpi", replace
}
*

}
*

*****************
***Panel Paris***
*****************

{

clear all
set more off

use "$maindir_replication${sep}Part_B${sep}dta${sep}master_sample_long.dta"

keep if code_au2010=="001"

drop if logearn==.
drop if code_uu2010==""
drop if code_commune==""
drop if year==.

*

gen typo = 0
replace typo = 1 if code_commune=="75056" //Paris
replace typo = 2 if code_uu2010=="00851" & code_commune!="75056" //part of 77,78,91,92,93,94,95
replace typo = 3 if code_uu2010!="00851" //rest of the Urban Area


*

forvalue i = 1/3 {
	gen logearn_`i' = logearn if typo==`i'
	gen labor_`i' = labor if typo==`i'
	gen obs_`i' = (typo==`i')
	
	gen logearn_`i'_m = logearn if typo==`i' & male==1
	gen labor_`i'_m = labor if typo==`i' & male==1
	gen obs_`i'_m = (typo==`i' & male==1)
	
	gen logearn_`i'_f = logearn if typo==`i' & male==0
	gen labor_`i'_f = labor if typo==`i' & male==0
	gen obs_`i'_f = (typo==`i' & male==0)	
}

gen logearn_4 = logearn if code_commune!="75056"
gen labor_4 = labor if code_commune!="75056"
gen obs_4 = (code_commune!="75056")

gen logearn_4_m = logearn if code_commune!="75056" & male==1
gen labor_4_m = labor if code_commune!="75056" & male==1
gen obs_4_m = (code_commune!="75056" & male==1)

gen logearn_4_f = logearn if code_commune!="75056" & male==0
gen labor_4_f = labor if code_commune!="75056" & male==0
gen obs_4_f = (code_commune!="75056" & male==0)

	
*

foreach i in 10 25 50 75 90 95 99 {
	global p`i' = "p`i'_1 = logearn_1 p`i'_2 = logearn_2 p`i'_3 = logearn_3 p`i'_4 = logearn_4 p`i'_1_m = logearn_1_m p`i'_2_m = logearn_2_m p`i'_3_m = logearn_3_m p`i'_4_m = logearn_4_m p`i'_1_f = logearn_1_f p`i'_2_f = logearn_2_f p`i'_3_f = logearn_3_f p`i'_4_f = logearn_4_f"
}

*

collapse (sum) obs_* (mean) labor_1 labor_2 labor_3 labor_4 labor_1_m labor_2_m labor_3_m labor_4_m labor_1_f labor_2_f labor_3_f labor_4_f (p10) $p10 (p25) $p25 (p50) $p50 (p75) $p75 (p90) $p90 (p95) $p95 (p99) $p99, by(year)  

drop if year==.

*

forvalue i = 1/4 {
	gen l_mean_`i' = log(labor_`i')
	gen l_mean_`i'_m = log(labor_`i'_m)
	gen l_mean_`i'_f = log(labor_`i'_f)
}
*
foreach i in 2 3 4 {
	foreach p in l_mean p10 p25 p50 p75 p90 p95 p99 {
		gen `p'_paris_`i' = `p'_1 - `p'_`i'
		gen `p'_paris_`i'_m = `p'_1_m - `p'_`i'_m
		gen `p'_paris_`i'_f = `p'_1_f - `p'_`i'_f
	}
}
*
foreach var in l_mean_paris_2 l_mean_paris_2_m l_mean_paris_2_f p10_paris_2 p10_paris_2_m p10_paris_2_f p25_paris_2 p25_paris_2_m p25_paris_2_f p50_paris_2 p50_paris_2_m p50_paris_2_f p75_paris_2 p75_paris_2_m p75_paris_2_f p90_paris_2 p90_paris_2_m p90_paris_2_f p95_paris_2 p95_paris_2_m p95_paris_2_f p99_paris_2 p99_paris_2_m p99_paris_2_f l_mean_paris_3 l_mean_paris_3_m l_mean_paris_3_f p10_paris_3 p10_paris_3_m p10_paris_3_f p25_paris_3 p25_paris_3_m p25_paris_3_f p50_paris_3 p50_paris_3_m p50_paris_3_f p75_paris_3 p75_paris_3_m p75_paris_3_f p90_paris_3 p90_paris_3_m p90_paris_3_f p95_paris_3 p95_paris_3_m p95_paris_3_f p99_paris_3 p99_paris_3_m p99_paris_3_f l_mean_paris_4 l_mean_paris_4_m l_mean_paris_4_f p10_paris_4 p10_paris_4_m p10_paris_4_f p25_paris_4 p25_paris_4_m p25_paris_4_f p50_paris_4 p50_paris_4_m p50_paris_4_f p75_paris_4 p75_paris_4_m p75_paris_4_f p90_paris_4 p90_paris_4_m p90_paris_4_f p95_paris_4 p95_paris_4_m p95_paris_4_f p99_paris_4 p99_paris_4_m p99_paris_4_f {
	qui: sum `var' if year==1993
	gen n_`var' = `var' - r(mean)
}

save "$maindir_replication${sep}Part_B${sep}dta${sep}panel_1993_2015_paris", replace

}
*


***********************
***Public Employment***
***********************

{

clear all
set more off

use "$sources${sep}panel_ts_2018.dta"

***Rename variables 
rename nninouv idnr
rename annai b_year
rename an year
rename sir siren

***Period (1991-2016)
drop if year < 1991
drop if year > 2016 

***Observations with a problematic identifier
*1994, 2003 and 2004 have a higher share of missing identifiers Including these observations entails abnormal drops in bottom percentiles 
drop if substr(idnr,1,1)=="F"

drop if idnr=="" | idnr=="" //missing workers' identifier

drop if sb <=0 | sb==. //"Particuliers employeurs" have 0 sb

***Year of death (ie the individual leaves the sample)
bys idnr : egen yod = max(year)
replace yod = yod+1

***Year of birth
*Some missing values but always the same dob for a given individual
sort idnr sb
by idnr : replace b_year = b_year[_N] if  b_year[_N]!=.
by idnr : replace b_year = b_year[_N-1] if  b_year[_N]==. & b_year[_N-1]!=.
by idnr : replace b_year = b_year[_N-2] if  b_year[_N]==. & b_year[_N-1]==. & b_year[_N-2]!=.

drop if b_year==.
gen ag = year-b_year + 1

***Gender
*People are coded as male if we observe mainly sx==1
gen male = .
destring sx, replace
by idnr : egen total_sx = total(sx)
gen non_empty = 0
replace non_empty = 1 if sx==0 | sx==1
by idnr : egen total_nonempty = total(non_empty)
by idnr : replace male = 1 if total_nonempty!=0 & (total_sx >=05 * total_nonempty)
by idnr : replace male = 0 if total_nonempty!=0 & (total_sx <05 * total_nonempty)
drop if male==.
drop total_sx non_empty total_nonempty sx


*************
***Filters***
*************

***France métropolitaine
**Keep jobs in France Métropolitaine (dept in [01,95] + 2A-2B Corse)

forvalue i = 1/9 {
replace dept="0`i'" if dept=="`i'"
}

gen dept2=substr(dept,1,2)
replace dept = "" if dept=="ZZ" 
replace dept = "" if dept2=="00" | dept2=="" | dept2==""
replace dept = "99" if inlist(dept, "9A", "9B", "9C", "9D", "XX")
replace dept = "99" if inlist(dept2,"97","98")
drop if dept=="99" | dept==""
drop dept2

***Age
*Ag is defined as: ag = year-b_year + 1

keep if ag >=24
keep if ag <=55

*Drop people that should not be observe 1991 due to the sampling procedure

drop if inlist(ag,25,29,33,35,37,43,45,55) & year==1991

***Occupation
*(cs1/cs2: since 1984)

drop if cs1=="0" //cs1=="0" corresponds to ce=="A" (workers collecting unemployment insurance)
drop if cs1=="1" //AGRICULTURE
drop if cs2=="44" // CLERGY
drop if substr(cs2,1,1)=="7" //TRAINEES AND APPRENTICES
drop if cs1=="7" //TRAINEES AND APPRENTICES


***Workers collecting unemployment
*(since 2008)
drop if ce=="A"

keep if inlist(filtre,"0","1")

***Sirens fictifs Pseudo siren Particuliers employeurs
gen first=substr(siren,1,1)
drop if first=="S" // Particuliers employeurs
replace siren = "" if first=="P" // Pseudo siren
replace siren = "" if first=="F"
drop first


***Exclude workers employed by households
*Observed only since 2009

drop if domempl =="7" // Particuliers employeurs

***Wages and hours

replace nbheur = . if nbheur <0

replace nbheur = 2496 if nbheur > 2496 & nbheur!=. //48*52=2496 (Loi Seguin 1987) 

gen empty_h = (nbheur==0 | nbheur==.)

***Total gross/net labour income and nber of hours (Public + private)

bys idnr year: egen total_g_wage = total(sb)
bys idnr year: egen total_n_wage = total(sn)
bys idnr year: egen total_netnet_wage = total(netnet)
bys idnr year: egen total_hours = total(nbheur)

bys idnr year: egen empty_hours = total(empty_h)
replace empty_hours = 1 if empty_hours>0
drop empty_h

*Inconsistent earnings

replace total_g_wage = . if total_g_wage > 15 * total_n_wage & total_n_wage>0 & total_n_wage!= .

gen wage_inc = total_g_wage


**************************
***Additional variables***
**************************

***Public Employment
{


***Keep the same sample as in the comprehensive DADS
*(domempl: since 1986)

**Head count
*Using the variable "Domempl"
*(domempl: since 1986)

gen dom_fp_etat = (domempl =="1")
gen dom_fp_local = (domempl =="2")
gen dom_fp_hopitaux = (domempl =="3")
gen dom_fp_others = (domempl =="4")

gen dom_private = 1
replace dom_private = 0 if domempl =="1" | domempl =="2" | domempl =="3" | domempl =="4"

*domempl =="1" // Fonction publique d'Etat
*domempl =="2" // Fonction publique territoriale
*domempl =="3" // Fonction publique hospitalière
*domempl =="4" // Autres organismes publics administratifs

*Using the variable "Sect"
gen sec_fp_etat = (sect =="ETAT")
gen sec_fp_local = (sect =="FPT")
gen sec_fp_hopitaux = (sect =="FPH")
gen sec_fp_others = (sect =="ADMIN")

gen sec_private = 1
replace sec_private = 0 if domempl =="ETAT" | domempl =="FPT" | domempl =="FPH" | domempl =="ADMIN"

**Weighted by dp

foreach var in dom sec {
gen `var'_fp_etat_dp = dp if `var'_fp_etat==1
gen `var'_fp_local_dp = dp if `var'_fp_local==1
gen `var'_fp_hopitaux_dp = dp if `var'_fp_hopitaux==1
gen `var'_fp_others_dp = dp if `var'_fp_others==1

gen `var'_private_dp = dp if `var'_private==1
}

do "$maindir_replication${sep}Part_A${sep}do${sep}0_Initialize.do"

global base_price_index = ${base_price}-${yrfirst}+1	// The base year nominal values are converted to real. 

gen total_g_wage_cst = total_g_wage

forvalue yr=1991/2016 {
	local cpi_index = `yr'-${yrfirst}+1
	replace total_g_wage_cst= total_g_wage_cst/cpimat[`cpi_index',1] if year==`yr'	//Coverting to real values
}

_pctile total_g_wage_cst, p(99.999)
replace total_g_wage_cst= r(r1) if total_g_wage_cst>=r(r1) & total_g_wage_cst !=. 

gen logearn=.

forvalue yr=1991/2016 {
	replace logearn = log(total_g_wage_cst) if year==`yr' & total_g_wage_cst>=rmininc[`yr'-${yrfirst}+1,1] & total_g_wage_cst != . 
}

***Main Job

sort idnr year sb
by idnr year: gen main_job = (_n==_N)

*weighted by days

foreach var in dom sec {
	gen `var'_fp_etat_mj_dp = dp if `var'_fp_etat==1 & main_job==1
	gen `var'_fp_local_mj_dp = dp if `var'_fp_local==1 & main_job==1
	gen `var'_fp_hopitaux_mj_dp = dp if `var'_fp_hopitaux==1 & main_job==1
	gen `var'_fp_others_mj_dp = dp if `var'_fp_others==1 & main_job==1

	gen `var'_private_mj_dp = dp if `var'_private==1 & main_job==1
}

**Main job full time

gen mj_ft = 0
replace mj_ft = 1 if ce=="C" & main_job==1

gen mj_ft_dp = 0
replace mj_ft_dp = dp if mj_ft==1

**Weighted by days

foreach var in dom sec {
	gen `var'_fp_etat_mj_ft_dp = dp if `var'_fp_etat==1 & mj_ft==1
	gen `var'_fp_local_mj_ft_dp = dp if `var'_fp_local==1 & mj_ft==1
	gen `var'_fp_hopitaux_mj_ft_dp = dp if `var'_fp_hopitaux==1 & mj_ft==1
	gen `var'_fp_others_mj_ft_dp = dp if `var'_fp_others==1 & mj_ft==1

	gen `var'_private_mj_ft_dp = dp if `var'_private==1 & mj_ft==1
}
*

**Main job full year full time

gen ft_fy = 0
replace ft_fy = 1 if ce=="C" & main_job==1 & dp >=350

foreach var in dom sec {
	gen `var'_fp_etat_ftfy = (ft_fy==1 & `var'_fp_etat==1)
	gen `var'_fp_local_ftfy = (ft_fy==1 & `var'_fp_local==1)
	gen `var'_fp_hopitaux_ftfy = (ft_fy==1 & `var'_fp_hopitaux==1)
	gen `var'_fp_others_ftfy = (ft_fy==1 & `var'_fp_others==1)

	gen `var'_private_ftfy = (ft_fy==1 & `var'_private==1)
}
*

}
*

***************
***Geography***
***************

{
**Place of residence & place of work

gen lgt1=length(comr)
replace comr="" if lgt1<3

gen lgt2=length(comt)
replace comt="" if lgt2<3

drop lgt1 lgt2

gen end_r = substr(comr,3,1)
gen keep_r = 1 if inlist(end_r,"0","1","2","3","4","5","6","7","8") | end_r=="9"
replace comr="" if keep_r!=1
*
gen end_t = substr(comt,3,1)
gen keep_t = 1 if inlist(end_t,"0","1","2","3","4","5","6","7","8") | end_t=="9"
replace comt="" if keep_t!=1

*
drop end_r keep_r end_t keep_t


*"Département" of residence
replace depr = "" if inlist(depr, "00", "0", "ZZ", "96")
replace depr = "" if inlist(depr, "AR", "BE", "BH", "CA", "CB", "CT", "IA", "ME", "MN")
replace depr = "" if inlist(depr, "NW", "SE", "SG", "SU")
replace depr = "" if inlist(depr, "97", "970", "971", "972", "973", "974", "975", "976", "977")
replace depr = "" if inlist(depr, "978", "98", "99", "9A", "9B", "9C", "9D","B6")
replace depr = "" if inlist(depr, "986", "987", "988")

gen commune_r = ""
gen commune_t = ""
replace commune_r = depr + comr if depr!="" & comr!=""
replace commune_t = dept + comt if dept!="" & comt!=""

sort idnr year sb

by idnr year : replace commune_r = commune_r[_N] if commune_r[_N]!=""
by idnr year : replace commune_r = commune_r[_N-1] if commune_r[_N]=="" & commune_r[_N-1]!=""
by idnr year : replace commune_r = commune_r[_N-2] if commune_r[_N]=="" & commune_r[_N-1]=="" & commune_r[_N-2]!=""
by idnr year : replace commune_r = commune_r[_N-3] if commune_r[_N]=="" & commune_r[_N-1]=="" & commune_r[_N-2]=="" & commune_r[_N-3]!=""


gen code_commune = commune_t
replace code_commune = commune_r if commune_t=="" | substr(commune_t,3,3)=="000"

*Paris
replace code_commune = "75056" if inlist(code_commune, "75101","75102","75103","75104","75105","75106","75107","75108","75109")
replace code_commune = "75056" if inlist(code_commune, "75110","75111","75112","75113","75114","75115","75116","75117","75118")
replace code_commune = "75056" if inlist(code_commune, "75119","75120")
*Lyon
replace code_commune = "69123" if inlist(code_commune, "69381","69382","69383","69384","69385","69386","69387","69388","69389")
*Marseille
replace code_commune = "13055" if inlist(code_commune, "13201","13202","13203","13204","13205","13206","13207","13208","13209")
replace code_commune = "13055" if inlist(code_commune, "13210","13211","13212","13213","13214","13215","13216")

*Changes in the municipality code over times
replace code_commune="02580" if code_commune=="02247"
replace code_commune="02559" if code_commune=="02611"
replace code_commune="02738" if code_commune=="02630"
replace code_commune="04155" if code_commune=="04029"
replace code_commune="07031" if code_commune=="07046"
replace code_commune="07147" if code_commune=="07125"
replace code_commune="07284" if code_commune=="07246"
replace code_commune="07147" if code_commune=="07320"
replace code_commune="08169" if code_commune=="08221"
replace code_commune="14697" if code_commune=="14624"
replace code_commune="16339" if code_commune=="16022"
replace code_commune="16297" if code_commune=="16159"
replace code_commune="19275" if code_commune=="19267"
replace code_commune="21084" if code_commune=="21551"
replace code_commune="25485" if code_commune=="25577"
replace code_commune="26262" if code_commune=="26151"
replace code_commune="26091" if code_commune=="26158"
replace code_commune="26020" if code_commune=="26265"
replace code_commune="27297" if code_commune=="27328"
replace code_commune="33342" if code_commune=="33286"
replace code_commune="35064" if code_commune=="35036"
replace code_commune="35206" if code_commune=="35073"
replace code_commune="38139" if code_commune=="38227"
replace code_commune="39385" if code_commune=="39005"
replace code_commune="39367" if code_commune=="39524"
replace code_commune="49206" if code_commune=="49210"
replace code_commune="50216" if code_commune=="50303"
replace code_commune="50129" if code_commune=="50383"
replace code_commune="51158" if code_commune=="51021"
replace code_commune="51158" if code_commune=="51024"
replace code_commune="51158" if code_commune=="51383"
replace code_commune="53062" if code_commune=="53024"
replace code_commune="54602" if code_commune=="55227"
replace code_commune="55060" if code_commune=="55337"
replace code_commune="55060" if code_commune=="55354"
replace code_commune="57132" if code_commune=="57157"
replace code_commune="57133" if code_commune=="57170"
replace code_commune="57150" if code_commune=="57420"   
replace code_commune="59350" if code_commune=="59298"
replace code_commune="59350" if code_commune=="59355"
replace code_commune="59183" if code_commune=="59380"
replace code_commune="61483" if code_commune=="61022"
replace code_commune="61136" if code_commune=="61254"
replace code_commune="62473" if code_commune=="62110"
replace code_commune="62178" if code_commune=="62482"
replace code_commune="62473" if code_commune=="62575"
replace code_commune="63303" if code_commune=="63217"
replace code_commune="65141" if code_commune=="65008"
replace code_commune="65003" if code_commune=="65365"
replace code_commune="66010" if code_commune=="66200"
replace code_commune="67474" if code_commune=="67211"
replace code_commune="68216" if code_commune=="68236"
replace code_commune="69172" if code_commune=="69011"
replace code_commune="70004" if code_commune=="70073"
replace code_commune="71443" if code_commune=="71211"
replace code_commune="71101" if code_commune=="71560"
replace code_commune="72241" if code_commune=="72206"
replace code_commune="74256" if code_commune=="74246"
replace code_commune="76217" if code_commune=="76466"   
replace code_commune="79195" if code_commune=="79017"
replace code_commune="79013" if code_commune=="79037"
replace code_commune="79013" if code_commune=="79305"
replace code_commune="80369" if code_commune=="80370"
replace code_commune="80086" if code_commune=="80772"
replace code_commune="81132" if code_commune=="81107"
replace code_commune="85036" if code_commune=="85068"
replace code_commune="88106" if code_commune=="88034"
replace code_commune="88227" if code_commune=="88396"
replace code_commune="89014" if code_commune=="89140"

 
*
 
merge m:1 code_commune using "$nomenclatures${sep}table_passage_2003_2019.dta"

replace codgeo_2019 = code_commune if codgeo_2019==""
drop if _merge==2
drop code_commune _merge
rename codgeo_2019 code_commune
 
merge m:1 code_commune using "$nomenclatures${sep}AU2010.dta"
drop if _merge==2
drop _merge commune

*
 
merge m:1 code_commune using "$nomenclatures${sep}UU2010_final.dta"
drop if _merge==2
drop _merge commune

}
*
 
***Irrelevant variables

drop depr dept regr regt comt comr
drop cs1 cs2 pcs4 pcs_v2
drop sb sn netnet s_brut
drop debremu finremu
drop domempl sect nes5
drop pan25 pannouv entpan
drop ag depnai age
drop ce filtre xp ancsir apen apet apen2 apet2 nbsa_et nbsa_ent


*

compress

save "$maindir_replication${sep}Part_B${sep}dta${sep}panel_final_1988_2017_share_public.dta", replace

}
*

*Compute the shares
{
clear all
set more off

*Programs to compute normalized shares

capture program drop base_year
program define base_year
	args variable def measure year
	gen l_`2'_`1'_`3' = log(`2'_`1'_`3')
	qui sum l_`2'_`1'_`3' if year==`4'
	gen n_`2'_`1'_`3' = (l_`2'_`1'_`3' - r(mean))
	replace n_`2'_`1'_`3' = exp(n_`2'_`1'_`3') - 1
	drop l_`2'_`1'_`3'	
end

*

capture program drop base_year_local
program define base_year_local
	args variable def measure year local
	gen l_`2'_`1'_`3'_`5' = log(`2'_`1'_`3'_`5')
	qui sum l_`2'_`1'_`3'_`5' if year==`4'
	gen n_`2'_`1'_`3'_`5' = (l_`2'_`1'_`3'_`5' - r(mean))
	replace n_`2'_`1'_`3'_`5' = exp(n_`2'_`1'_`3'_`5') - 1
	drop l_`2'_`1'_`3'_`5'	
end
	
foreach v in dom sec {
	
	use "$maindir_replication${sep}Part_B${sep}dta${sep}panel_final_1988_2017_share_public", clear

	drop if year<2002
	drop if code_uu2010==""
	drop if year==.
	drop if logearn==.

	replace statut_2012 = "P" if code_uu2010=="00851"

	*Employment by territory
	foreach job in `v'_fp_etat_ftfy `v'_fp_local_ftfy `v'_fp_hopitaux_ftfy `v'_fp_others_ftfy `v'_private_ftfy `v'_fp_etat_dp `v'_fp_local_dp `v'_fp_hopitaux_dp `v'_fp_others_dp `v'_private_dp {
		foreach var in B C I P R {
			gen `job'_`var' = `job' if statut_2012=="`var'"
		}
	}
	*
	foreach var in B C I P R {
		gen ft_fy_`var' = (statut_2012=="`var'" & ft_fy==1)
		gen dp_`var' = dp if statut_2012=="`var'"
	}


	*

	global territories_ftfy = "`v'_fp_etat_ftfy_B `v'_fp_etat_ftfy_C `v'_fp_etat_ftfy_I `v'_fp_etat_ftfy_P `v'_fp_etat_ftfy_R `v'_fp_local_ftfy_B `v'_fp_local_ftfy_C `v'_fp_local_ftfy_I `v'_fp_local_ftfy_P `v'_fp_local_ftfy_R `v'_fp_hopitaux_ftfy_B `v'_fp_hopitaux_ftfy_C `v'_fp_hopitaux_ftfy_I `v'_fp_hopitaux_ftfy_P `v'_fp_hopitaux_ftfy_R `v'_fp_others_ftfy_B `v'_fp_others_ftfy_C `v'_fp_others_ftfy_I `v'_fp_others_ftfy_P `v'_fp_others_ftfy_R `v'_private_ftfy_B `v'_private_ftfy_C `v'_private_ftfy_I `v'_private_ftfy_P `v'_private_ftfy_R ft_fy_B ft_fy_C ft_fy_I ft_fy_P ft_fy_R"
	global territories_dp = "`v'_fp_etat_dp_B `v'_fp_etat_dp_C `v'_fp_etat_dp_I `v'_fp_etat_dp_P `v'_fp_etat_dp_R `v'_fp_local_dp_B `v'_fp_local_dp_C `v'_fp_local_dp_I `v'_fp_local_dp_P `v'_fp_local_dp_R `v'_fp_hopitaux_dp_B `v'_fp_hopitaux_dp_C `v'_fp_hopitaux_dp_I `v'_fp_hopitaux_dp_P `v'_fp_hopitaux_dp_R `v'_fp_others_dp_B `v'_fp_others_dp_C `v'_fp_others_dp_I `v'_fp_others_dp_P `v'_fp_others_dp_R `v'_private_dp_B `v'_private_dp_C `v'_private_dp_I `v'_private_dp_P `v'_private_dp_R dp_B dp_C dp_I dp_P dp_R"

	global national_ftfy = "`v'_fp_etat_ftfy `v'_fp_hopitaux_ftfy `v'_fp_others_ftfy `v'_fp_local_ftfy `v'_private_ftfy ft_fy"
	global national_dp = "`v'_fp_etat_dp `v'_fp_hopitaux_dp `v'_fp_others_dp `v'_fp_local_dp `v'_private_dp dp" 

	collapse (sum) $territories_ftfy $territories_dp $national_ftfy $national_dp , by(year)

	drop if year==.


	**Convert to Shares

	*National

	foreach var in fp_etat_ftfy fp_local_ftfy fp_hopitaux_ftfy fp_others_ftfy private_ftfy {
		gen `v'_s_`var' = 100 * `v'_`var' / ft_fy
	}
	*
	
	foreach var in fp_etat_dp fp_local_dp fp_hopitaux_dp fp_others_dp private_dp {
		gen `v'_s_`var' = 100 * `v'_`var' / dp
	}

	*Local

	foreach var in fp_etat_ftfy fp_local_ftfy fp_hopitaux_ftfy fp_others_ftfy private_ftfy {
		foreach area in B C I P R {
			gen `v'_s_`var'_`area' = 100 * `v'_`var'_`area' / ft_fy_`area'
		}
	}
	*
	foreach var in fp_etat_dp fp_local_dp fp_hopitaux_dp fp_others_dp private_dp {
		foreach area in B C I P R {
			gen `v'_s_`var'_`area' = 100 * `v'_`var'_`area' / dp_`area'
		}
	}
	*
	
	***Ref 2002

	**National
	foreach var in ftfy dp {
		gen `v'_fp_total_`var' = `v'_fp_etat_`var' + `v'_fp_local_`var'+ `v'_fp_hopitaux_`var' + `v'_fp_others_`var'
		gen `v'_s_fp_total_`var' = `v'_s_fp_etat_`var' + `v'_s_fp_local_`var'+ `v'_s_fp_hopitaux_`var' + `v'_s_fp_others_`var'
			base_year fp_total `v' `var' 2002
			base_year s_fp_total `v' `var' 2002
	}
	*

	*By type of public employment
	foreach var in ftfy dp {
		foreach type in fp_etat fp_local fp_hopitaux fp_others {
			base_year `type' `v' `var' 2002
			base_year s_`type' `v' `var' 2002
		}
	}
	*

	**Local
	*Total employment in public sector
	foreach var in ftfy dp {
		foreach area in B C I P R {
			gen `v'_fp_total_`var'_`area' = `v'_fp_etat_`var'_`area' + `v'_fp_local_`var'_`area' + `v'_fp_hopitaux_`var'_`area' + `v'_fp_others_`var'_`area'
			gen `v'_s_fp_total_`var'_`area' = `v'_s_fp_etat_`var'_`area' + `v'_s_fp_local_`var'_`area' + `v'_s_fp_hopitaux_`var'_`area' + `v'_s_fp_others_`var'_`area'
			base_year_local fp_total `v' `var' 2002 `area'
			base_year_local s_fp_total `v' `var' 2002 `area'
		}
	}
	*
	*By type of public employment
	foreach var in ftfy dp {
		foreach type in fp_etat fp_local fp_hopitaux fp_others {
			foreach area in B C I P R {
				base_year_local `type' `v' `var' 2002 `area'
				base_year_local s_`type' `v' `var' 2002 `area'
			}
		}
	}
	*
	
	compress

	save "$maindir_replication${sep}Part_B${sep}dta${sep}`v'_panel_share_public_2002_2016", replace
}
*

}
*
